
#include <stdio.h>

static void getaddr(char* ipxaddr);
static void setaddr(char* ipxaddr);
static int checkipx();

main(int argc, char *argv[])
{
	if(argc!=2 && checkipx()==1)
	{
		unsigned char address[12];
		address[10]=0;
		address[11]=0;
		getaddr(&address[0]);
		printf("Current IPX address: %2x:%2x:%2x:%2x %2x:%2x:%2x:%2x:%2x:%2x\n",
			((int)address[0]&0x00FF), ((int)address[1]&0x00FF),
			((int)address[2]&0x00FF), ((int)address[3]&0x00FF),
	
			((int)address[4]&0x00FF), ((int)address[5]&0x00FF),
			((int)address[6]&0x00FF), ((int)address[7]&0x00FF),
			((int)address[8]&0x00FF), ((int)address[9]&0x00FF)
		);
		printf("\nTo change the Network number, type\n\nsetipx <hexadecimal IPX network number>\n\nExample: setipx 1\n");

		
	}
	else if(checkipx()==1)
	{
		unsigned int result;
		unsigned long netnum = 0;
		result=sscanf(argv[1],"%lx",&netnum);	
		if(result==1)
		{
		
			unsigned char address[12];
			address[10]=0;
			address[11]=0;
		
			getaddr(&address[0]);
			printf("Old IPX address: %2x:%2x:%2x:%2x %2x:%2x:%2x:%2x:%2x:%2x\n",
				((int)address[0]&0x00FF), ((int)address[1]&0x00FF),
				((int)address[2]&0x00FF), ((int)address[3]&0x00FF),
	
				((int)address[4]&0x00FF), ((int)address[5]&0x00FF),
				((int)address[6]&0x00FF), ((int)address[7]&0x00FF),
				((int)address[8]&0x00FF), ((int)address[9]&0x00FF)
			);
		
		
			address[3]=netnum&0xFF;
			address[2]=(netnum&0xFF00)>>8;
			address[1]=(netnum&0xFF0000)>>16;
			address[0]=(netnum&0xFF000000)>>24;

			setaddr(&address[0]);
			getaddr(&address[0]);
			printf("New IPX address: %2x:%2x:%2x:%2x %2x:%2x:%2x:%2x:%2x:%2x\n",
				((int)address[0]&0x00FF), ((int)address[1]&0x00FF),
				((int)address[2]&0x00FF), ((int)address[3]&0x00FF),
			
				((int)address[4]&0x00FF), ((int)address[5]&0x00FF),
				((int)address[6]&0x00FF), ((int)address[7]&0x00FF),
				((int)address[8]&0x00FF), ((int)address[9]&0x00FF)
			);
		}
		else printf("\nSorry, I could not understand you.\nTo change the Network number, type\n\nsetipx <hexadecimal IPX network number>\n\nExample: setipx 1\n");
	}
	else printf("IPX not detected. INT 7A must be populated.");
	
}

static int checkipx()
{
	int vecseg, vecoff;

	asm push ax;
	asm push bx;
	asm push es;	
	asm push 0;
	asm pop es;	

	asm mov ax, es:1E8h;
	asm mov bx, es:1EAh;
	asm mov vecseg, ax;
	asm mov vecoff, bx;
	
	asm pop es;
	asm pop bx;
	asm pop ax;

	if(vecoff==0&&vecseg==0) return 0;
	return 1;
}

static void setaddr(char* ipxaddr)
{
	asm push ax; 
	asm push bx; 
	asm push cx;
	asm push es;
	asm push si;
	asm push di;

	asm mov bx,24h;
	asm push ss;
	asm pop es;
	asm mov si,ipxaddr;
	asm int 7ah;

	asm pop di;
	asm pop si;
	asm pop es;
	asm pop cx;
	asm pop bx; 
	asm pop ax; 
}

static void getaddr(char* ipxaddr)
{
	asm push ax; 
	asm push bx; 
	asm push es;
	asm push si;

	asm mov bx,9h;
	asm push ss;
	asm pop es;
	asm mov si,ipxaddr;
	asm int 7ah;


	asm pop si;
	asm pop es;
	asm pop bx; 
	asm pop ax; 
}